From a499df5fa65bd07273d329691b5362b5ccf611c6 Mon Sep 17 00:00:00 2001
From: Rakesh Pandit <rakesh@fedoraproject.org>
Date: Wed, 20 May 2009 18:07:59 +0530
Subject: [PATCH]  Initial importer and exporter - flickr and picasa merge.

---
 data/COPYING                          |  339 +++++++++++++++++++++++++++++++++
 data/README                           |   18 ++
 src/common/flickr.cpp                 |  276 +++++++++++++++++++++++++++
 src/common/flickr.h                   |  102 ++++++++++
 src/common/flickrconf.cpp             |   39 ++++
 src/common/flickrconf.h               |   37 ++++
 src/common/utils.cpp                  |   54 ++++++
 src/common/utils.h                    |   31 +++
 src/importer/flickr-import-window.cpp |   99 ++++++++++
 src/importer/flickr-import-window.h   |   52 +++++
 src/importer/import-tree-model.cpp    |   83 ++++++++
 src/importer/import-tree-model.h      |   50 +++++
 src/importer/picasaweb-source.cpp     |  177 +++++++++++++++++
 src/importer/picasaweb-source.h       |  125 ++++++++++++
 14 files changed, 1482 insertions(+), 0 deletions(-)
 create mode 100644 data/COPYING
 create mode 100644 data/README
 create mode 100644 src/common/flickr.cpp
 create mode 100644 src/common/flickr.h
 create mode 100644 src/common/flickrconf.cpp
 create mode 100644 src/common/flickrconf.h
 create mode 100644 src/common/utils.cpp
 create mode 100644 src/common/utils.h
 create mode 100644 src/importer/flickr-import-window.cpp
 create mode 100644 src/importer/flickr-import-window.h
 create mode 100644 src/importer/import-tree-model.cpp
 create mode 100644 src/importer/import-tree-model.h
 create mode 100644 src/importer/picasaweb-source.cpp
 create mode 100644 src/importer/picasaweb-source.h

diff --git a/data/COPYING b/data/COPYING
new file mode 100644
index 0000000..d511905
--- /dev/null
+++ b/data/COPYING
@@ -0,0 +1,339 @@
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+	    How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License along
+    with this program; if not, write to the Free Software Foundation, Inc.,
+    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.
diff --git a/data/README b/data/README
new file mode 100644
index 0000000..c338581
--- /dev/null
+++ b/data/README
@@ -0,0 +1,18 @@
+Image files and corresponding license. image_LICENSE.txt file in this
+folder contains the license text.
+
+Files			License		Copyright
+--------------------------------------------------
+mode-browse-16.png	GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+mode-browse-22.png	GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+mode-browse-24.png	GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+mode-browse-32.png	GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+mode-browse.svg		GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+tag-16.png		GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+tag-22.png		GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+tag-new-16.png		GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+tag-new-22.png		GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+tag-new-24.png		GPLv2+		Jakub <jimmac AT gmail DOT com> and Novell, Inc
+
+Note: GPLv2+ here means 'GPL version 2 or later'.
+These pictures are *used with permission* from author.
diff --git a/src/common/flickr.cpp b/src/common/flickr.cpp
new file mode 100644
index 0000000..843bc4e
--- /dev/null
+++ b/src/common/flickr.cpp
@@ -0,0 +1,276 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <iostream>
+#include <map>
+#include <fstream>
+#include <cstring>
+#include <libnm_glib.h>
+#include <flickcurl.h>
+
+#include "flickr.h"
+#include "flickrconf.h"
+#include "utils.h"
+
+namespace flickr {
+
+	class NoFrobException {
+	public:
+		NoFrobException()
+			{ }
+		std::string get_message() {return "Not able to get frob from flickr!";}
+	};
+
+	class NoAuthTokenException {
+	public:
+		NoAuthTokenException()
+			{ }
+		std::string get_message() {return "Not able to get auth token from flickr!";}
+	};
+
+	class FlickcurlException {
+		std::string msg;
+	public:
+		FlickcurlException(std::string str)
+			{ msg = str;}
+		std::string get_message() {return msg;}
+	};
+
+	flickr::flickr() throw() {
+		frob = "";
+		auth_token = "";
+
+		fc = NULL;
+		set_initialized(false);
+		initialize_flickr_api();
+	}
+
+	flickr::~flickr() throw() {
+		close_flickr_api();
+	}
+
+	void
+	flickr::get_auth_token() throw() {
+
+		char * c_auth_token;
+		c_auth_token = flickcurl_auth_getToken(fc, frob.c_str());
+
+		if (c_auth_token)
+			auth_token = std::string(c_auth_token);
+		else
+			throw NoAuthTokenException();
+
+		flickcurl_set_auth_token(fc, auth_token.c_str());
+		return;
+	}
+
+	bool
+	flickr::check_auth_done() throw() {
+		if (flickcurl_auth_checkToken(fc, auth_token.c_str()))
+			return true;
+		return false;
+	}
+
+	flickcurl_upload_status*
+	flickr::upload_photo(flickcurl_upload_params params) throw() {
+		return flickcurl_photos_upload_params(fc, &params);
+	}
+
+	flickcurl_photos_list*
+	flickr::get_photo_list_not_in_any_set() throw() {
+		flickcurl_photos_list_params list_params;
+		flickcurl_photos_list* list = NULL;
+		flickcurl_photos_list_params_init(&list_params);
+		list = flickcurl_photos_getNotInSet_params(fc,
+												   -1,
+												   -1,
+												   NULL,
+												   NULL,
+												   -1,
+												   &list_params
+												   );
+		return list;
+	}
+
+	flickcurl_photos_list*
+	flickr::get_photo_list_in_set(const char* photoset_id) throw() {
+		flickcurl_photos_list* list=NULL;
+		flickcurl_photos_list_params list_params;
+		flickcurl_photos_list_params_init(&list_params);
+		list = flickcurl_photosets_getPhotos_params(fc, photoset_id,
+													-1,
+													&list_params);
+
+		return list;
+	}
+
+	flickcurl_photoset**
+	flickr::get_photosets_list() throw() {
+		flickcurl_photoset** photoset_list=NULL;
+		const char* user_id=NULL;
+		photoset_list = flickcurl_photosets_getList(fc, user_id);
+		return photoset_list;
+	}
+
+	dictionary
+	flickr::get_thumbnail_uri_from_photo_list(flickcurl_photos_list* photo_list) throw() {
+		int i = 0;
+		dictionary uri_dic;
+		char *uri;
+
+		for(i=0; photo_list->photos[i]; i++) {
+			uri = flickcurl_photo_as_source_uri(photo_list->photos[i], 's');
+			uri_dic[photo_list->photos[i]->id] = std::string(uri);
+		}
+
+		return uri_dic;
+	}
+
+	dictionary
+	flickr::get_title_from_photo_list(flickcurl_photos_list* photo_list) throw() {
+		int i = 0;
+		dictionary title_dic;
+		char *title;
+
+		for(i=0; photo_list->photos[i]; i++) {
+			title = photo_list->photos[i]->fields[PHOTO_FIELD_title].string;
+			title_dic[photo_list->photos[i]->id] = std::string(title);
+		}
+
+		return title_dic;
+	}
+
+	std::vector<std::string>
+	flickr::get_id_from_photo_list(flickcurl_photos_list* photo_list) throw() {
+		int i = 0;
+		std::vector<std::string> id_list;
+
+		for(i=0; photo_list->photos[i]; i++) {
+			id_list.push_back(std::string(photo_list->photos[i]->id));
+		}
+
+		return id_list;
+	}
+
+	// Debugging Api - Will be removed later
+	void
+	flickr::return_photo_list(flickcurl_photos_list* photo_list) throw() {
+		int i = 0;
+		int field_type;
+		char* uri;
+
+		for(i=0; photo_list->photos[i]; i++) {
+			uri = flickcurl_photo_as_source_uri(photo_list->photos[i], 's');
+			std::cout << i << "    :    " << photo_list->photos[i]->id << "     "<< uri <<std::endl;
+			for(field_type=0; field_type <= PHOTO_FIELD_LAST; field_type++) {
+				flickcurl_field_value_type datatype=photo_list->photos[i]->fields[field_type].type;
+
+				if(datatype != VALUE_TYPE_NONE)
+					fprintf(stdout, "%s with %s '%s' / %d\n",
+							flickcurl_get_photo_field_label((flickcurl_photo_field_type)field_type),
+							flickcurl_get_field_value_type_label(datatype),
+							photo_list->photos[i]->fields[field_type].string,
+							photo_list->photos[i]->fields[field_type].integer);
+			}
+		}
+		return;
+	}
+
+	std::string
+	flickr::get_auth_url(std::string permission) throw() {
+		libnm_glib_state state;
+		libnm_glib_ctx* nm_ctx = libnm_glib_init();
+		state = libnm_glib_get_network_state(nm_ctx);
+		libnm_glib_shutdown(nm_ctx);
+		
+		if (state != LIBNM_ACTIVE_NETWORK_CONNECTION) {
+			return "";
+		}
+		get_frob();
+		set_initialized(true);
+
+		dictionary req_vars;
+		std::string api_key = flickrconf::getApiKey();
+		std::string perms = permission;
+
+		req_vars["api_key"] = api_key;
+		req_vars["perms"] = perms;
+		req_vars["frob"] = frob;
+
+		std::string base_url = flickrconf::getAuthPrefix();
+		return get_signed_url(base_url, req_vars);
+	}
+
+	void
+	flickr::close_flickr_api() throw() {
+		flickcurl_free(fc);
+		flickcurl_finish();
+	}
+
+	static void
+	my_message_handler(void* user_data, const char *message) {
+		std::string msg(message);
+		std::string errormsg = "flickr api: ERROR: " + msg;
+		// close_flickr_api();
+		throw FlickcurlException(errormsg);
+	}
+
+	void
+	flickr::initialize_flickr_api() throw() {
+		// Get frob using flickcurl.
+		flickcurl_init();
+		fc = flickcurl_new();
+		flickcurl_set_error_handler(fc, my_message_handler, NULL);
+		return;
+	}
+
+	void
+	flickr::get_frob() throw() {
+		char *cfrob;
+
+		std::string shared_key = flickrconf::getSharedKey();
+		std::string api_key = flickrconf::getApiKey();
+
+		flickcurl_set_api_key(fc, api_key.c_str());
+		flickcurl_set_shared_secret(fc, shared_key.c_str());
+		cfrob = flickcurl_auth_getFrob(fc);
+
+		if (cfrob)
+			frob = std::string(cfrob);
+		else
+			throw NoFrobException();
+
+		return;
+	}
+
+	std::string
+	flickr::get_signed_url(const std::string base_url, dictionary req_vars) throw() {
+		std::string shared_key = flickrconf::getSharedKey();
+		std::string signature(shared_key);
+		std::string auth_url(base_url);
+
+		for (dictionary::const_iterator i = req_vars.begin(); i != req_vars.end(); i++) {
+			signature += i->first + i->second;
+			auth_url += i->first + "=" + i->second + "&";
+		}
+
+		auth_url += "api_sig=" + utils::md5sum(signature);
+		return auth_url;	
+	}
+
+};
diff --git a/src/common/flickr.h b/src/common/flickr.h
new file mode 100644
index 0000000..bbbecd4
--- /dev/null
+++ b/src/common/flickr.h
@@ -0,0 +1,102 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef FLICKR_H
+#define FLICKR_H
+
+#include <iostream>
+#include <map>
+#include <vector>
+#include <flickcurl.h>
+
+namespace flickr {
+
+typedef std::map<std::string, std::string> dictionary;
+
+class flickr {
+public:
+	flickr() throw();
+
+	virtual
+		~flickr() throw();
+
+	std::string
+		get_auth_url(std::string permission) throw();
+
+	bool
+		check_auth_done() throw();
+
+	flickcurl_upload_status*
+		upload_photo(flickcurl_upload_params params) throw();
+
+	flickcurl_photos_list*
+		get_photo_list_not_in_any_set() throw();
+
+	flickcurl_photos_list*
+		get_photo_list_in_set(const char* photoset_id) throw();
+
+	// Debugging Api - Will be removed later
+	//	std::vector<dictionary>
+	void
+		return_photo_list(flickcurl_photos_list* photo_list) throw();
+
+	void
+		get_auth_token() throw();
+
+	dictionary
+		get_thumbnail_uri_from_photo_list(flickcurl_photos_list* photo_list) throw();
+
+	dictionary
+		get_title_from_photo_list(flickcurl_photos_list* photo_list) throw();
+
+	std::vector<std::string>
+		get_id_from_photo_list(flickcurl_photos_list* photo_list) throw();
+
+	
+	flickcurl_photoset**
+		get_photosets_list() throw();
+
+private:
+	std::string frob;
+	std::string auth_token;
+	flickcurl *fc;
+	bool initialized;
+
+	void
+		close_flickr_api() throw();
+
+	// Remove it once memory leark in case of crash is fixed.
+	//	void
+	//		my_message_handler(void* user_data, const char *message);
+
+	void
+		initialize_flickr_api() throw();
+
+	void
+		get_frob() throw();
+
+	std::string
+		get_signed_url(const std::string base_url, dictionary req_vars) throw();
+
+	void set_initialized(bool value) throw() {initialized = value;}
+	bool is_initialized() throw() {return initialized;}
+};
+
+};
+
+#endif
diff --git a/src/common/flickrconf.cpp b/src/common/flickrconf.cpp
new file mode 100644
index 0000000..9f4d932
--- /dev/null
+++ b/src/common/flickrconf.cpp
@@ -0,0 +1,39 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "flickrconf.h"
+
+namespace flickrconf {
+
+	std::string getSharedKey() {
+		// Confirm keys from [rakesh]
+		std::string shared_key = "ece1d65e052be919";
+		return shared_key;
+	}
+
+	std::string getApiKey() {
+		// Confirm keys from [rakesh]
+		std::string api_key = "bc071df116992b4a0abc8db01135eb4b";
+		return api_key;
+	}
+
+	std::string getAuthPrefix() {
+		std::string prefix = "http://www.flickr.com/services/auth/?";
+		return prefix;
+	}
+};
diff --git a/src/common/flickrconf.h b/src/common/flickrconf.h
new file mode 100644
index 0000000..2f7d8d7
--- /dev/null
+++ b/src/common/flickrconf.h
@@ -0,0 +1,37 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef FLICKR_CONF_H
+#define FLICKR_CONF_H
+
+#include <string>
+
+namespace flickrconf {
+
+	// Returns shared key.
+	std::string getSharedKey();
+
+	// Returns shared API keyyeah
+	std::string getApiKey();
+
+	// Return flickr URL
+	std::string getAuthPrefix();
+
+};
+
+#endif
diff --git a/src/common/utils.cpp b/src/common/utils.cpp
new file mode 100644
index 0000000..e16d574
--- /dev/null
+++ b/src/common/utils.cpp
@@ -0,0 +1,54 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "utils.h"
+
+#include <string>
+#include <stdexcept>
+
+#include <cstdio>
+#include <cstdlib>
+
+namespace utils {
+
+	std::string md5sum(std::string str) {
+
+		std::string cmd = "echo -n " + str + " | md5sum -t";
+		FILE* pfd = popen(cmd.c_str(), "r");
+		std::string sum, result;
+
+		if (pfd == 0) {
+			throw std::runtime_error("md5sum sum could not be calculated" \
+									 " using coreutils command.");
+		}
+
+		while(!feof(pfd)) {
+			char buf[1024] = {0};
+
+			if ( fgets(buf, sizeof(buf), pfd) > 0 ) {
+				result.append(std::string(buf));
+			}
+
+		}
+		pclose(pfd);
+
+		// Remove last 4 non-sum characters from result string.
+		sum = result.substr(0, result.length() - 4);
+		return sum;
+	}
+};
diff --git a/src/common/utils.h b/src/common/utils.h
new file mode 100644
index 0000000..cc3dc2b
--- /dev/null
+++ b/src/common/utils.h
@@ -0,0 +1,31 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef UTILS_H
+#define UTILS_H
+
+#include <string>
+
+namespace utils {
+
+	// Returns shared key.
+	std::string md5sum(std::string);
+
+};
+
+#endif
diff --git a/src/importer/flickr-import-window.cpp b/src/importer/flickr-import-window.cpp
new file mode 100644
index 0000000..6b9988d
--- /dev/null
+++ b/src/importer/flickr-import-window.cpp
@@ -0,0 +1,99 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <iostream>
+#include "flickr-import-window.h"
+
+FlickrImportWindow::FlickrImportWindow()
+: button_quit(Gtk::Stock::QUIT)
+{
+  set_title("Select images to import: ");
+  set_border_width(5);
+  set_default_size(400, 200);
+
+  vbox = (Gtk::VBox * const )get_vbox();
+
+  scrolled_window.add(tree_view);
+
+  scrolled_window.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
+
+  vbox->pack_start(scrolled_window);
+
+  button_import.set_label("Import");
+  button_quit.set_label("Cancel");
+  button_import.signal_clicked().connect( sigc::mem_fun(*this,
+    &FlickrImportWindow::on_button_import) );
+
+
+  vbox->pack_start(button_box, Gtk::PACK_SHRINK);
+  button_box.pack_start(button_quit, Gtk::PACK_SHRINK);
+  button_box.pack_start(button_import, Gtk::PACK_SHRINK);
+
+  button_box.set_border_width(5);
+  button_box.set_layout(Gtk::BUTTONBOX_END);
+  button_quit.signal_clicked().connect(sigc::mem_fun(*this,
+              &FlickrImportWindow::on_button_quit) );
+
+  ref_tree_model = ImportTreeModel::create();
+  tree_view.set_model(ref_tree_model);
+
+  tree_view.enable_model_drag_source();
+  tree_view.enable_model_drag_dest();
+
+  tree_view.append_column("S. no.", ref_tree_model->m_Columns.m_col_id);
+  tree_view.append_column("Title", ref_tree_model->m_Columns.m_col_name);
+
+  show_all_children();
+}
+
+FlickrImportWindow::~FlickrImportWindow()
+{
+}
+
+void FlickrImportWindow::on_button_quit()
+{
+  hide();
+}
+
+void
+FlickrImportWindow::on_button_import() throw()
+{
+}
+
+void
+FlickrImportWindow::make_imported_tree_per_set(std::vector<std::string> id_list, \
+						  dictionary title_dic, \
+						  std::string set_name) throw()
+{
+  int count = 0;
+  Gtk::TreeModel::Row row = *(ref_tree_model->append());
+  row[ref_tree_model->m_Columns.m_col_id] = 1;
+  row[ref_tree_model->m_Columns.m_col_name] = set_name.c_str();
+  row[ref_tree_model->m_Columns.m_col_draggable] = false;
+  row[ref_tree_model->m_Columns.m_col_receivesdrags] = true;
+
+  for(std::vector<std::string>::iterator it = id_list.begin(); it!=id_list.end(); ++it) {
+    count++;
+    Gtk::TreeModel::Row childrow = *(ref_tree_model->append(row.children()));
+    childrow[ref_tree_model->m_Columns.m_col_id] = count;
+    childrow[ref_tree_model->m_Columns.m_col_name] = title_dic[(*it)].c_str();
+    childrow[ref_tree_model->m_Columns.m_col_draggable] = true;
+    childrow[ref_tree_model->m_Columns.m_col_receivesdrags] = false;
+  }
+
+}
diff --git a/src/importer/flickr-import-window.h b/src/importer/flickr-import-window.h
new file mode 100644
index 0000000..a8c53c7
--- /dev/null
+++ b/src/importer/flickr-import-window.h
@@ -0,0 +1,52 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <gtkmm.h>
+#include <flickcurl.h>
+#include "import-tree-model.h"
+
+typedef std::map<std::string, std::string> dictionary;
+
+class FlickrImportWindow :
+  public Gtk::Dialog
+{
+public:
+  FlickrImportWindow();
+  virtual ~FlickrImportWindow();
+
+  void
+  make_imported_tree_per_set(std::vector<std::string> id_list, dictionary title_dic, \
+				std::string set_name) throw();
+
+protected:
+  virtual void on_button_quit();
+
+  Gtk::VBox* vbox;
+
+  Gtk::ScrolledWindow scrolled_window;
+  Gtk::TreeView tree_view;
+  Glib::RefPtr<ImportTreeModel> ref_tree_model;
+
+  Gtk::HButtonBox button_box;
+  Gtk::Button button_quit;
+  Gtk::Button button_import;
+
+  virtual void
+  on_button_import() throw();
+
+};
diff --git a/src/importer/import-tree-model.cpp b/src/importer/import-tree-model.cpp
new file mode 100644
index 0000000..b3f0feb
--- /dev/null
+++ b/src/importer/import-tree-model.cpp
@@ -0,0 +1,83 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "import-tree-model.h"
+#include <iostream>
+
+ImportTreeModel::ImportTreeModel()
+{
+  set_column_types(m_Columns);
+}
+
+Glib::RefPtr<ImportTreeModel> ImportTreeModel::create()
+{
+  return Glib::RefPtr<ImportTreeModel>( new ImportTreeModel() );
+}
+
+bool
+ImportTreeModel::row_draggable_vfunc(const Gtk::TreeModel::Path& path) const
+{
+  ImportTreeModel* unconstThis = const_cast<ImportTreeModel*>(this);
+  const_iterator iter = unconstThis->get_iter(path);
+
+  if(iter)
+  {
+    Row row = *iter;
+    bool is_draggable = row[m_Columns.m_col_draggable];
+    return is_draggable;
+  }
+
+#ifdef GLIBMM_VFUNCS_ENABLED
+  return Gtk::TreeStore::row_draggable_vfunc(path);
+#else
+  return false;
+#endif
+}
+
+bool
+ImportTreeModel::row_drop_possible_vfunc(const Gtk::TreeModel::Path& dest,
+        const Gtk::SelectionData& selection_data) const
+{
+  Gtk::TreeModel::Path dest_parent = dest;
+  bool dest_is_not_top_level = dest_parent.up();
+  if(!dest_is_not_top_level || dest_parent.empty())
+  {
+    //The user wants to move something to the top-level.
+    //Let's always allow that.
+  }
+  else
+  {
+    //TODO: Add a const version of get_iter to TreeModel:
+    ImportTreeModel* unconstThis = const_cast<ImportTreeModel*>(this);
+    const_iterator iter_dest_parent = unconstThis->get_iter(dest_parent);
+
+    if(iter_dest_parent)
+    {
+      Row row = *iter_dest_parent;
+      bool receives_drags = row[m_Columns.m_col_receivesdrags];
+      return receives_drags;
+    }
+  }
+
+#ifdef GLIBMM_VFUNCS_ENABLED
+  return Gtk::TreeStore::row_drop_possible_vfunc(dest, selection_data);
+#else
+  return false;
+#endif
+}
+
diff --git a/src/importer/import-tree-model.h b/src/importer/import-tree-model.h
new file mode 100644
index 0000000..31b2895
--- /dev/null
+++ b/src/importer/import-tree-model.h
@@ -0,0 +1,50 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <gtkmm.h>
+
+class ImportTreeModel : public Gtk::TreeStore
+{
+protected:
+  ImportTreeModel();
+
+public:
+
+  class ModelColumns : public Gtk::TreeModel::ColumnRecord
+  {
+  public:
+
+    ModelColumns()
+    { add(m_col_id); add(m_col_name); add(m_col_draggable); add(m_col_receivesdrags); }
+
+    Gtk::TreeModelColumn<int> m_col_id;
+    Gtk::TreeModelColumn<Glib::ustring> m_col_name;
+    Gtk::TreeModelColumn<bool> m_col_draggable;
+    Gtk::TreeModelColumn<bool> m_col_receivesdrags;
+  };
+
+  ModelColumns m_Columns;
+
+  static Glib::RefPtr<ImportTreeModel> create();
+
+protected:
+  virtual bool row_draggable_vfunc(const Gtk::TreeModel::Path& path) const;
+  virtual bool row_drop_possible_vfunc(const Gtk::TreeModel::Path& dest, const Gtk::SelectionData& selection_data) const;
+  
+};
+
diff --git a/src/importer/picasaweb-source.cpp b/src/importer/picasaweb-source.cpp
new file mode 100644
index 0000000..6cf9c84
--- /dev/null
+++ b/src/importer/picasaweb-source.cpp
@@ -0,0 +1,177 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <iostream>
+
+#include "config.h"
+#include "picasaweb-source.h"
+#include "progress-observer.h"
+
+namespace Solang
+{
+
+AuthWindow::AuthWindow() throw() :
+	auth_table(3, 2, true),
+	button_cancel(Gtk::Stock::QUIT),
+	button_ok(Gtk::Stock::OK),
+	la_username("Username:"),
+	la_password("Password:")
+{
+	auth_done = false;
+
+	en_username.set_editable(true);
+	en_password.set_editable(true);
+
+	set_title("Authentication Picasaweb");
+
+	Gtk::VBox * const dialog_vbox = get_vbox();
+	dialog_vbox->pack_start(auth_table);
+
+	auth_table.attach(la_username, 0, 1, 0, 1);
+	auth_table.attach(en_username, 1, 2, 0, 1);
+	auth_table.attach(la_password, 0, 1, 1, 2);
+	auth_table.attach(en_password, 1, 2, 1, 2);
+	auth_table.attach(button_cancel, 0, 1, 2, 3);
+	auth_table.attach(button_ok, 1, 2, 2, 3);
+
+	button_cancel.signal_clicked().connect( sigc::mem_fun(*this,
+		&AuthWindow::on_button_cancel) );
+
+	button_ok.signal_clicked().connect( sigc::mem_fun(*this,
+		&AuthWindow::on_button_ok) );
+
+	en_password.set_visibility(false);
+
+	show_all_children();
+}
+
+AuthWindow::~AuthWindow() throw()
+{
+}
+
+void
+AuthWindow::on_button_cancel() throw()
+{
+	
+	hide();
+}
+
+void
+AuthWindow::on_button_ok() throw()
+{
+	username = en_username.get_text();
+	password = en_password.get_text();
+	auth_done = true;
+	hide();
+}
+
+PicasawebSource::PicasawebSource() throw() :
+    PhotoSource(),
+    button_()
+{
+	button_.set_label("Authenticate");
+	button_.signal_clicked().connect( sigc::mem_fun(*this,
+		&PicasawebSource::on_button_clicked_authentication) );
+
+	set_authurl_confirmed(false);
+	set_auth_info(false);
+}
+
+PicasawebSource::~PicasawebSource() throw()
+{
+}
+
+PhotoPtr
+PicasawebSource::import(const PhotoPtr & photo,
+                     const IStoragePtr & storage,
+                     const TagList & tag, Database & db,
+                     const ProgressObserverPtr & observer) throw()
+{
+	return PhotoPtr(photo);
+}
+
+PhotoList
+PicasawebSource::import(const PhotoList & photos,
+                     const IStoragePtr & storage,
+                     const TagList & tag, Database & db,
+                     const ProgressObserverPtr & observer) throw()
+{
+    observer->set_num_events(photos.size());
+    observer->set_event_description("Importing photos");
+
+	PhotoList imported_photos;
+    return imported_photos;
+}
+
+PhotoList
+PicasawebSource::import(const IStoragePtr & storage, const TagList & tag,
+                     Database & db,
+                     const ProgressObserverPtr & observer) throw()
+{
+    PhotoList files;
+    return import(files, storage, tag, db, observer);
+}
+
+void
+PicasawebSource::on_button_clicked_authentication() throw()
+{
+
+	if(is_auth_info_present()) {
+		button_.set_label("Confirmed!");
+		return;
+	}
+
+	AuthWindow auth_window;
+	auth_window.run();
+
+	if (auth_window.is_auth_done()) {
+		picasaweb_user = auth_window.username;
+		picasaweb_passwd = auth_window.password;
+
+		set_auth_info(true);
+		button_.set_label("Confirm via Picasaweb!");
+	}
+
+	return;
+}
+
+Gtk::Widget &
+PicasawebSource::get_browser() throw()
+{
+    return button_;
+}
+
+Glib::ustring
+PicasawebSource::get_label() const throw()
+{
+    return Glib::ustring("_Picasa...");
+}
+
+Glib::ustring
+PicasawebSource::get_name() const throw()
+{
+    return Glib::ustring("Picasaweb");
+}
+
+Gtk::StockID
+PicasawebSource::get_stock_id() const throw()
+{
+    return Gtk::StockID();
+}
+
+} // namespace Solang
diff --git a/src/importer/picasaweb-source.h b/src/importer/picasaweb-source.h
new file mode 100644
index 0000000..9135f16
--- /dev/null
+++ b/src/importer/picasaweb-source.h
@@ -0,0 +1,125 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
+/*
+ * Copyright (C) Rakesh Pandit 2009 <rakesh@fedoraproject.org>
+ * 
+ * Solang is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Solang is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef SOLANG_PICASAWEB_SOURCE_H
+#define SOLANG_PICASAWEB_SOURCE_H
+
+#include <glibmm.h>
+#include <gtkmm.h>
+
+#include "photo-source.h"
+
+namespace Solang
+{
+
+class AuthWindow: 
+	public Gtk::Dialog
+{
+public:
+	AuthWindow() throw();
+	virtual
+		~AuthWindow() throw();
+	bool
+		is_auth_done() throw() {return auth_done;}
+protected:
+	// Signal handlers
+	virtual void
+		on_button_cancel() throw();
+
+	Gtk::Table auth_table;
+	Gtk::Button button_cancel, button_ok;
+	Gtk::Entry en_username, en_password;
+	Gtk::Label la_username, la_password;
+private:
+	std::string username;
+	std::string password;
+	bool auth_done;
+
+	virtual void
+		on_button_ok() throw();
+
+	// To share authentication info
+	friend class PicasawebSource;
+};
+
+class PicasawebSource :
+    public PhotoSource, public Gtk::Window
+{
+public:
+    PicasawebSource() throw();
+
+    virtual
+    ~PicasawebSource() throw();
+
+    virtual PhotoPtr
+    import(const PhotoPtr & photo, const IStoragePtr & storage,
+           const TagList & tag, Database & db,
+           const ProgressObserverPtr & observer) throw();
+
+    virtual PhotoList
+    import(const PhotoList & photos, const IStoragePtr & storage,
+           const TagList & tag, Database & db,
+           const ProgressObserverPtr & observer) throw();
+
+    virtual PhotoList
+    import(const IStoragePtr & storage, const TagList & tag,
+           Database & db, const ProgressObserverPtr & observer) throw();
+
+    virtual Widget &
+    get_browser() throw();
+
+    virtual Glib::ustring
+    get_label() const throw();
+
+    virtual Glib::ustring
+    get_name() const throw();
+
+    virtual Gtk::StockID
+    get_stock_id() const throw();
+
+	bool
+		is_authurl_confirmed() const throw() {return url_confirmed;}
+
+	bool
+		is_auth_info_present() const throw() {return auth_info;}
+
+protected:
+	Gtk::Button button_;
+
+private:
+	virtual void
+		on_button_clicked_authentication() throw();
+
+	void
+		set_authurl_confirmed(bool value) throw() {url_confirmed = value;}
+
+	void
+		set_auth_info(bool value) throw() {auth_info = value;}
+
+	std::string picasaweb_user;
+	std::string picasaweb_passwd;
+	std::string picasaweb_auth_url;
+
+	bool auth_info;
+	bool url_confirmed;
+	std::string url;
+};
+
+} // namespace Solang
+
+#endif // SOLANG_PICASAWEB_SOURCE_H
-- 
1.6.0.6

